<?php

namespace App\Services;

use App\Repositories\ChecklistCategory;

class ChecklistCategoryService
{
    private $checklistCategoryRepository;

    public function __construct(ChecklistCategory $checklistCategoryRepository)
    {
        $this->checklistCategoryRepository = $checklistCategoryRepository;
    }

    public function save(array $data)
    {
        if (isset($data['id'])) {
            $checklistCategory = $this->checklistCategoryRepository->findOrFail($data['id']);
            $checklistCategory->update($data);
        } else {
            $checklistCategory = $this->checklistCategoryRepository->create($data);
        }

        return $checklistCategory;
    }

    public function delete($id)
    {
        $checklistCategory = $this->checklistCategoryRepository->findOrFail($id);
        $checklistCategory->delete();
    }

    public function get($id)
    {
        return $this->checklistCategoryRepository->findOrFail($id);
    }

    public function getAll()
    {
        return $this->checklistCategoryRepository->all();
    }

    public function with(array $children)
    {
        return $this->checklistCategoryRepository->with($children)->get();
    }

    public function getOneWith($id, array $children)
    {
        return $this->checklistCategoryRepository->with($children)->findOrFail($id);
    }
}